diff --git a/xen/Rules.mk b/xen/Rules.mk
index 8839dca..f7ddc69 100644
--- a/xen/Rules.mk
+++ b/xen/Rules.mk
@@ -45,7 +45,7 @@ ALL_OBJS-y               += $(BASEDIR)/common/built_in.o
 ALL_OBJS-y               += $(BASEDIR)/drivers/built_in.o
 ALL_OBJS-y               += $(BASEDIR)/xsm/built_in.o
 ALL_OBJS-y               += $(BASEDIR)/arch/$(TARGET_ARCH)/built_in.o
-ALL_OBJS-$(x86)          += $(BASEDIR)/crypto/built_in.o
+ALL_OBJS-$(CONFIG_X86)   += $(BASEDIR)/crypto/built_in.o
 
 CFLAGS += -nostdinc -fno-builtin -fno-common
 CFLAGS += -Werror -Wredundant-decls -Wno-pointer-arith
diff --git a/xen/arch/x86/Makefile b/xen/arch/x86/Makefile
index d4e507a..6448a23 100644
--- a/xen/arch/x86/Makefile
+++ b/xen/arch/x86/Makefile
@@ -5,7 +5,7 @@ subdir-y += hvm
 subdir-y += mm
 subdir-y += oprofile
 
-subdir-$(x86_64) += x86_64
+subdir-$(CONFIG_X86_64) += x86_64
 
 obj-bin-y += alternative.init.o
 obj-y += apic.o
@@ -67,7 +67,7 @@ obj-$(crash_debug) += gdbstub.o
 
 x86_emulate.o: x86_emulate/x86_emulate.c x86_emulate/x86_emulate.h
 
-efi-$(x86_64) := $(shell if [ ! -r $(BASEDIR)/include/xen/compile.h -o \
+efi-$(CONFIG_X86_64) := $(shell if [ ! -r $(BASEDIR)/include/xen/compile.h -o \
                                 -O $(BASEDIR)/include/xen/compile.h ]; then \
                          echo '$(TARGET).efi'; fi)
 
diff --git a/xen/arch/x86/Rules.mk b/xen/arch/x86/Rules.mk
index 4ca69a1..b76a754 100644
--- a/xen/arch/x86/Rules.mk
+++ b/xen/arch/x86/Rules.mk
@@ -22,10 +22,6 @@ $(call as-insn-check,CFLAGS,CC,".equ \"x\"$$(comma)1", \
                      -U__OBJECT_LABEL__ -DHAVE_GAS_QUOTED_SYM \
                      '-D__OBJECT_LABEL__=$(subst $(BASEDIR)/,,$(CURDIR))/$$@')
 
-x86 := y
-x86_32 := n
-x86_64 := y
-
 shadow-paging ?= y
 bigmem        ?= n
 
diff --git a/xen/arch/x86/efi/Makefile b/xen/arch/x86/efi/Makefile
index 1daa7ac..c6c2fa6 100644
--- a/xen/arch/x86/efi/Makefile
+++ b/xen/arch/x86/efi/Makefile
@@ -4,7 +4,7 @@ obj-y += stub.o
 
 create = test -e $(1) || touch -t 199901010000 $(1)
 
-efi := $(filter y,$(x86_64)$(shell rm -f disabled))
+efi := $(filter y,$(CONFIG_X86_64)$(shell rm -f disabled))
 efi := $(if $(efi),$(shell $(CC) $(filter-out $(CFLAGS-y) .%.d,$(CFLAGS)) -c check.c 2>disabled && echo y))
 efi := $(if $(efi),$(shell $(LD) -mi386pep --subsystem=10 -o check.efi check.o 2>disabled && echo y))
 efi := $(if $(efi),$(shell rm disabled)y,$(shell $(call create,boot.init.o); $(call create,runtime.o)))
diff --git a/xen/arch/x86/mm/Makefile b/xen/arch/x86/mm/Makefile
index aeccdfc..61b7428 100644
--- a/xen/arch/x86/mm/Makefile
+++ b/xen/arch/x86/mm/Makefile
@@ -6,9 +6,9 @@ obj-y += p2m.o p2m-pt.o p2m-ept.o p2m-pod.o
 obj-y += altp2m.o
 obj-y += guest_walk_2.o
 obj-y += guest_walk_3.o
-obj-$(x86_64) += guest_walk_4.o
-obj-$(x86_64) += mem_paging.o
-obj-$(x86_64) += mem_sharing.o
+obj-$(CONFIG_X86_64) += guest_walk_4.o
+obj-$(CONFIG_X86_64) += mem_paging.o
+obj-$(CONFIG_X86_64) += mem_sharing.o
 
 guest_walk_%.o: guest_walk.c Makefile
 	$(CC) $(CFLAGS) -DGUEST_PAGING_LEVELS=$* -c $< -o $@
diff --git a/xen/arch/x86/mm/hap/Makefile b/xen/arch/x86/mm/hap/Makefile
index 68f2bb5..14cb29d 100644
--- a/xen/arch/x86/mm/hap/Makefile
+++ b/xen/arch/x86/mm/hap/Makefile
@@ -1,7 +1,7 @@
 obj-y += hap.o
 obj-y += guest_walk_2level.o
 obj-y += guest_walk_3level.o
-obj-$(x86_64) += guest_walk_4level.o
+obj-$(CONFIG_X86_64) += guest_walk_4level.o
 obj-y += nested_hap.o
 obj-y += nested_ept.o
 
diff --git a/xen/common/Makefile b/xen/common/Makefile
index 8ab15ba..a8132db 100644
--- a/xen/common/Makefile
+++ b/xen/common/Makefile
@@ -65,7 +65,7 @@ obj-$(xenoprof)    += xenoprof.o
 
 obj-$(CONFIG_COMPAT) += $(addprefix compat/,domain.o kernel.o memory.o multicall.o tmem_xen.o xlat.o)
 
-subdir-$(x86_64) += hvm
+subdir-$(CONFIG_X86_64) += hvm
 
 subdir-$(coverage) += gcov
 
diff --git a/xen/drivers/acpi/Makefile b/xen/drivers/acpi/Makefile
index 3bb626e..d8a4299 100644
--- a/xen/drivers/acpi/Makefile
+++ b/xen/drivers/acpi/Makefile
@@ -1,11 +1,11 @@
 subdir-y += tables
 subdir-y += utilities
-subdir-$(x86) += apei
+subdir-$(CONFIG_X86) += apei
 
 obj-bin-y += tables.init.o
 obj-$(HAS_NUMA) += numa.o
 obj-y += osl.o
 obj-y += pmstat.o
 
-obj-$(x86) += hwregs.o
-obj-$(x86) += reboot.o
+obj-$(CONFIG_X86) += hwregs.o
+obj-$(CONFIG_X86) += reboot.o
diff --git a/xen/drivers/passthrough/Makefile b/xen/drivers/passthrough/Makefile
index a6657c5..cf1b1f1 100644
--- a/xen/drivers/passthrough/Makefile
+++ b/xen/drivers/passthrough/Makefile
@@ -1,9 +1,9 @@
-subdir-$(x86) += vtd
-subdir-$(x86) += amd
-subdir-$(x86_64) += x86
+subdir-$(CONFIG_X86) += vtd
+subdir-$(CONFIG_X86) += amd
+subdir-$(CONFIG_X86_64) += x86
 subdir-$(arm) += arm
 
 obj-y += iommu.o
-obj-$(x86) += io.o
+obj-$(CONFIG_X86) += io.o
 obj-$(CONFIG_HAS_PCI) += pci.o
 obj-$(CONFIG_HAS_DEVICE_TREE) += device_tree.o
diff --git a/xen/drivers/passthrough/vtd/Makefile b/xen/drivers/passthrough/vtd/Makefile
index 56d0153..f302653 100644
--- a/xen/drivers/passthrough/vtd/Makefile
+++ b/xen/drivers/passthrough/vtd/Makefile
@@ -1,4 +1,4 @@
-subdir-$(x86) += x86
+subdir-$(CONFIG_X86) += x86
 
 obj-y += iommu.o
 obj-y += dmar.o